
Ruby - Bug #21014

Prism doesn't set node_id on iseqs correctly

01/08/2025 12:35 AM - tenderlovemaking (Aaron Patterson)

Status: Closed   

Priority: Normal   

Assignee: prism   

Target version:    

ruby -v:  Backport: 3.1: DONTNEED, 3.2: DONTNEED, 3.3:

DONTNEED, 3.4: DONE

Description

Given this code:

f = proc { <<END }

  heredoc

END

iseq = RubyVM::InstructionSequence.of(f)

p iseq.to_a[4][:node_id]

 Output on parse.y:

$ ./miniruby --parser=parse.y test.rb

3

 Output on Prism:

$ ./miniruby test.rb

-1

 I don't expect node IDs on Prism to match parse.y, but I do expect the node id to be a legitimate node id.  For example, this program

should work:

f = proc { <<END }

  heredoc

END

iseq = RubyVM::InstructionSequence.of(f)

require "prism"

node_id = iseq.to_a[4][:node_id]

ast = Prism.parse(File.binread(__FILE__))

p ast.value.breadth_first_search { |node| node.node_id == node_id }

Associated revisions

Revision 63723c8d5908569918fb27e070ae5bc9de33c8bd - 01/08/2025 01:08 AM - tenderlovemaking (Aaron Patterson)

Correctly set node_id on iseq location

The iseq location object has a slot for node ids.  parse.y was correctly

populating that field but Prism was not. This commit populates the field

with the ast node id for that iseq

[Bug #21014]

Revision 63723c8d5908569918fb27e070ae5bc9de33c8bd - 01/08/2025 01:08 AM - tenderlovemaking (Aaron Patterson)

Correctly set node_id on iseq location

The iseq location object has a slot for node ids.  parse.y was correctly

populating that field but Prism was not. This commit populates the field
with the ast node id for that iseq

[Bug #21014]

Revision 63723c8d - 01/08/2025 01:08 AM - tenderlovemaking (Aaron Patterson)

Correctly set node_id on iseq location

The iseq location object has a slot for node ids.  parse.y was correctly

populating that field but Prism was not. This commit populates the field

with the ast node id for that iseq

[Bug #21014]

Revision 9240f01b1fbe5ea4f6a2017d35f8f605f84f0039 - 02/14/2025 01:54 AM - k0kubun (Takashi Kokubun)

merge revision(s) 63723c8d5908569918fb27e070ae5bc9de33c8bd: [Backport #21014]

    Correctly set node_id on iseq location

    The iseq location object has a slot for node ids.  parse.y was correctly

    populating that field but Prism was not. This commit populates the field

    with the ast node id for that iseq

    [Bug #21014]

Revision 9240f01b1fbe5ea4f6a2017d35f8f605f84f0039 - 02/14/2025 01:54 AM - k0kubun (Takashi Kokubun)

merge revision(s) 63723c8d5908569918fb27e070ae5bc9de33c8bd: [Backport #21014]

    Correctly set node_id on iseq location

    The iseq location object has a slot for node ids.  parse.y was correctly

    populating that field but Prism was not. This commit populates the field

    with the ast node id for that iseq

    [Bug #21014]

Revision 9240f01b - 02/14/2025 01:54 AM - k0kubun (Takashi Kokubun)

merge revision(s) 63723c8d5908569918fb27e070ae5bc9de33c8bd: [Backport #21014]

    Correctly set node_id on iseq location

    The iseq location object has a slot for node ids.  parse.y was correctly

    populating that field but Prism was not. This commit populates the field

    with the ast node id for that iseq

    [Bug #21014]

History

#1 - 01/08/2025 12:36 AM - tenderlovemaking (Aaron Patterson)

Fix sent here: https://github.com/ruby/ruby/pull/12527

#2 - 01/08/2025 01:08 AM - tenderlovemaking (Aaron Patterson)

- Status changed from Open to Closed

Applied in changeset git|63723c8d5908569918fb27e070ae5bc9de33c8bd.

Correctly set node_id on iseq location

The iseq location object has a slot for node ids.  parse.y was correctly

populating that field but Prism was not. This commit populates the field

with the ast node id for that iseq

[Bug #21014]

#3 - 01/11/2025 08:53 PM - kddnewton (Kevin Newton)

- Backport changed from 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3: UNKNOWN, 3.4: UNKNOWN to 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3: UNKNOWN,

3.4: REQUIRED
#4 - 02/14/2025 01:54 AM - k0kubun (Takashi Kokubun)

- Backport changed from 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3: UNKNOWN, 3.4: REQUIRED to 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3: UNKNOWN,

3.4: DONE

ruby_3_4 9240f01b1fbe5ea4f6a2017d35f8f605f84f0039 merged revision(s) 63723c8d5908569918fb27e070ae5bc9de33c8bd.

#5 - 03/30/2025 02:50 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3: UNKNOWN, 3.4: DONE to 3.1: DONTNEED, 3.2: DONTNEED, 3.3: DONTNEED,

3.4: DONE
